package org.ioc.daw.question;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

@Repository("questionHibernateDAO")
public class QuestionHibernateDAO implements QuestionDAO {

    @Autowired
    private SessionFactory sessionFactory;

    @Override
    public Question getById(Integer questionId) {
        return getSession().get(Question.class, questionId);
    }

    @Override
    public void save(Question question) {
        getSession().saveOrUpdate(question);
    }

   @Override
    public Question update(Question question) {
       return (Question) getSession().merge(question);
    }

    protected Session getSession() {
        return sessionFactory.getCurrentSession();
    }

}